-- PRUEBAS MODULO ESTADISTICO


/**********************************/
/********   ESTADISTICA 1  ********/
/**********************************/

-- PARA CADA PARLAMENTO: LA SUMA DE TODOS LOS GASTOS
-- DURANTE LOS 4 ULTIMOS AOS
-- INCLUYENDO TANTO LOS GASTOS DE LOR PARLAMENTOS
-- COMO LOS DE LOS PARLAMENTARIOS

-- RESULTADO OBTENIDO DE LA TABLA DEL MODULO ESTADISTICO
SELECT * FROM ESTAD_1 order by NOMPARLAMENT;



-- RESULTADO OBTENIDO REALIZANDO UNA SELECT 
-- CONTRA LA TABLA DESPESES
SELECT NOMPARLAMENT, SUM (IMPORT_DESPESA) from DESPESES 
WHERE (
EXTRACT (YEAR FROM DATA_DESPESA)= 2010 OR 
EXTRACT (YEAR FROM DATA_DESPESA)= 2011 OR
EXTRACT (YEAR FROM DATA_DESPESA)= 2012 OR
EXTRACT (YEAR FROM DATA_DESPESA)= 2013)
GROUP BY NOMPARLAMENT ORDER BY NOMPARLAMENT;


/**********************************/
/**********************************/
/********   ESTADISTICA 2  ********/
/**********************************/
/**********************************/


-- para un parlamento: DIFERENCIA EN EUROS
-- ENTRE EL DIPUTADO QUE HA GASTADO MAS Y 
-- EL QUE HA GASTADO MENOS

-- Ejemplo de resultado obtenido de la tabla del modulo estadistico
SELECT * FROM ESTAD_2 WHERE NOMPARLAMENT ='PARLAMENT DE CATALUNYA' AND ANY_ESTAD=2010;
-- Resultado obtenido = 84644


-- COMPARACION CON LOS RESULTADOS QUE SE OBTIENEN MIRANDO DIRECTAMENTE
-- EN LA TABLA DE DESPESES:

-- Importe del parlamentario que ha gastado MAYOR IMPORTE
-- para el PARLAMENT DE CATALUNYA
-- en el ao 2010
SELECT MAX(SUM (IMPORT_DESPESA)) FROM DESPESES 
WHERE 
    NOMPARLAMENT ='PARLAMENT DE CATALUNYA' AND 
    EXTRACT (YEAR FROM DATA_DESPESA)= 2010 AND
    TIPUSDESPESA='PARLAMENTARI'
GROUP BY CODIPARLAMENTARI;
-- Resultado: 696682

-- Importe del parlamentario que ha gastado MENOR IMPORTE
-- para el PARLAMENT DE CATALUNYA
-- en el ao 2010
SELECT MIN(SUM (IMPORT_DESPESA)) FROM DESPESES 
WHERE 
    NOMPARLAMENT ='PARLAMENT DE CATALUNYA' AND 
    EXTRACT (YEAR FROM DATA_DESPESA)= 2010 AND
    TIPUSDESPESA='PARLAMENTARI'
GROUP BY CODIPARLAMENTARI;
-- Resultado: 612038

-- La diferencia de los dos valores:
-- 696682 - 612038 = 84644


/**********************************/
/**********************************/
/********   ESTADISTICA 3  ********/
/**********************************/
/**********************************/

-- para un ao concreto:
-- El parlamento que ha tenido un gasto mayor

-- Ejemplo de resultado obtenido de la tabla del modulo estadistico
SELECT * FROM estad_3 WHERE ANY_ESTAD=2012;
-- El parlamento es: DEUSTCHER BUNDESTAG 

-- COMPARACION CON LOS RESULTADOS QUE SE OBTIENEN MIRANDO DIRECTAMENTE
-- EN LA TABLA DE DESPESES:
-- Vemos que DEUSTCHER BUNDESTAG  es el parlamento con gasto maximo
SELECT NOMPARLAMENT, SUM (IMPORT_DESPESA) FROM DESPESES 
WHERE EXTRACT (YEAR FROM DATA_DESPESA)=2012
GROUP BY NOMPARLAMENT
ORDER BY  SUM (IMPORT_DESPESA) DESC;


/**********************************/
/**********************************/
/********   ESTADISTICA 4  ********/
/**********************************/
/**********************************/

-- PARA UN PARLAMENTARIO; SU GASTO TOTAL EN LOS ULTIMOS 4 AOS

SELECT * FROM ESTAD_4
WHERE NOMPARLAMENT='PARLAMENTO VASCO' AND CODIPARLAMENTARI=7;
-- resultado obtenido: 2772306

-- COMPARACION CON LOS RESULTADOS QUE SE OBTIENEN MIRANDO DIRECTAMENTE
-- EN LA TABLA DE DESPESES:

SELECT SUM (IMPORT_DESPESA) FROM DESPESES
WHERE
    NOMPARLAMENT='PARLAMENTO VASCO' AND
    CODIPARLAMENTARI=7 AND (
    EXTRACT (YEAR FROM DATA_DESPESA)= 2010 OR 
    EXTRACT (YEAR FROM DATA_DESPESA)= 2011 OR
    EXTRACT (YEAR FROM DATA_DESPESA)= 2012 OR
    EXTRACT (YEAR FROM DATA_DESPESA)= 2013);
    


/**********************************/
/********   ESTADISTICA 5  ********/
/**********************************/

--MEDIA DEL GASTO DE TODOS LOS PARLAMENTARIOS EN UN AO

SELECT * FROM ESTAD_5 WHERE ANY_ESTAD=2011;
-- RESULTADO: 698169.75


-- COMPARACION CON LOS RESULTADOS QUE SE OBTIENEN MIRANDO DIRECTAMENTE
-- EN LA TABLA DE DESPESES:

-- SUMA DE LOS GASTOS TOTALES DE PARLAMENTARIOS EN EL AO 2011
SELECT SUM (IMPORT_DESPESA) FROM DESPESES 
WHERE 
    EXTRACT (YEAR FROM DATA_DESPESA)= 2011 AND
    TIPUSDESPESA='PARLAMENTARI';
-- Resultado: 41890185


-- NUMERO DE PARLAMENTARIOS QUE HAN REGISTRADO ALGUN GASTO EN EL AO 2011
SELECT COUNT (*) FROM(
  SELECT DISTINCT NOMPARLAMENT, CODIPARLAMENTARI 
  FROM DESPESES
  WHERE
    EXTRACT (YEAR FROM DATA_DESPESA)= 2011 AND
    TIPUSDESPESA='PARLAMENTARI'
  );
-- Resultado: 60

-- MEDIA RESULTANTE: 41890185/60 =  698169.75


/**********************************/
/********   ESTADISTICA 6  ********/
/**********************************/

-- PARA UN AO CONCRETO
-- EL PARLAMENTARIO QUE HA REGISTRADO UN MAYOR GASTO
-- Y EL QUE HA REGISTRADO UN MENOR GASTO
-- TENIENDO EN CUENTA TODOS LOS PARLAMENTOS
SELECT * FROM ESTAD_6 WHERE ANY_ESTAD=2012;



-- COMPARACION CON LOS RESULTADOS QUE SE OBTIENEN MIRANDO DIRECTAMENTE
-- EN LA TABLA DE DESPESES:
-- PARLAMENTARIO QUE HA REGISTRADO UN MAYOR GASTO:
SELECT * FROM (
   SELECT  NOMPARLAMENT, 
           CODIPARLAMENTARI, 
           SUM (IMPORT_DESPESA) AS TOTAL_PARLAMENTARI
   FROM DESPESES 
   WHERE 
       EXTRACT (YEAR FROM DATA_DESPESA)= 2012 AND
       TIPUSDESPESA='PARLAMENTARI' 
   GROUP BY NOMPARLAMENT, CODIPARLAMENTARI
   ORDER BY SUM (IMPORT_DESPESA) DESC
   )
WHERE ROWNUM = 1;

-- PARLAMENTARIO QUE HA REGISTRADO UN MENOR GASTO:
SELECT * FROM (
   SELECT  NOMPARLAMENT, 
           CODIPARLAMENTARI, 
           SUM (IMPORT_DESPESA) AS TOTAL_PARLAMENTARI
   FROM DESPESES 
   WHERE 
       EXTRACT (YEAR FROM DATA_DESPESA)= 2012 AND
       TIPUSDESPESA='PARLAMENTARI' 
   GROUP BY NOMPARLAMENT, CODIPARLAMENTARI
   ORDER BY SUM (IMPORT_DESPESA) ASC
   )
WHERE ROWNUM = 1;


/**********************************/
/**********************************/
/********   ESTADISTICA 7  ********/
/**********************************/
/**********************************/

-- PARA UN AO CONCRETO: NOMBRE DEL PARLAMENTO
-- CON UN MEDIO DE GASTO ASOCIADO A LOS PARLAMENTARIOS, MAS ALTA
-- Y VALOR DE DICHA MEDIA

-- PARLAMENTO CUYOS PARLAMENTARIOS TUVIERON UNA MEDIA DE GASTO MAYOR
-- DURANTE EL AO 2013
SELECT * FROM ESTAD_7 WHERE ANY_ESTAD=2013;


-- COMPARACION CON LOS RESULTADOS QUE SE OBTIENEN MIRANDO DIRECTAMENTE
-- EN LA TABLA DE DESPESES:
-- LA SIGUIENTE SELECT DEVUELVE LAS MEDIAS DE GASTO DE TODOS LOS PARLAMENTARIOS DE CADA PARLAMENTO
-- DURANTE EL AO 2013
-- ORDENADOS DE MAYOR A MENOR MEDIA

SELECT SUM (DESPESES1.IMPORT_DESPESA) AS SUMA ,
       EXTRACT (YEAR FROM DESPESES1.DATA_DESPESA)  AS ANNY, 
      (   SELECT COUNT (DISTINCT DESPESES2.CODIPARLAMENTARI ) FROM DESPESES DESPESES2 
          WHERE 
          EXTRACT (YEAR FROM DESPESES1.DATA_DESPESA) = EXTRACT (YEAR FROM DESPESES2.DATA_DESPESA)
          AND DESPESES1.NOMPARLAMENT=DESPESES2.NOMPARLAMENT
          AND DESPESES2.TIPUSDESPESA='PARLAMENTARI'
          AND ( EXTRACT (YEAR FROM DESPESES2.DATA_DESPESA)=2013 ) 
      ) AS NOMBRE,
      ROUND (SUM (DESPESES1.IMPORT_DESPESA
            )/(
          SELECT COUNT (DISTINCT DESPESES2.CODIPARLAMENTARI ) FROM DESPESES DESPESES2
          WHERE 
          EXTRACT (YEAR FROM DESPESES1.DATA_DESPESA) = EXTRACT (YEAR FROM DESPESES2.DATA_DESPESA)
          AND DESPESES1.NOMPARLAMENT=DESPESES2.NOMPARLAMENT
          AND DESPESES2.TIPUSDESPESA='PARLAMENTARI'
          AND ( EXTRACT (YEAR FROM DESPESES2.DATA_DESPESA)=2013 )
      ),2) AS MEDIA,
       DESPESES1.NOMPARLAMENT
FROM DESPESES DESPESES1  
WHERE DESPESES1.TIPUSDESPESA='PARLAMENTARI' 
     AND ( EXTRACT (YEAR FROM DESPESES1.DATA_DESPESA)=2013 ) 
GROUP BY EXTRACT (YEAR FROM DESPESES1.DATA_DESPESA), DESPESES1.NOMPARLAMENT
ORDER BY MEDIA DESC;


/**********************************/
/**********************************/
/********   ESTADISTICA 8  ********/
/**********************************/
/**********************************/

--SUMA DE TODOS LOS GASTOS DE TODOS LOS PARLAMENTOS DURANTE UN AO

--DATOS PARA EL AO 2010 DE LA TABLA DE ESTADISTICAS
SELECT * FROM ESTAD_8 WHERE ANY_ESTAD=2010;


-- COMPARACION CON LOS RESULTADOS QUE SE OBTIENEN MIRANDO DIRECTAMENTE
-- EN LA TABLA DE DESPESES
SELECT SUM (IMPORT_DESPESA)
FROM DESPESES
WHERE EXTRACT (YEAR FROM DATA_DESPESA)=2010;
